(* addList : int list -> int
 *)
let rec addList ns =
  match ns with
  | [] -> 0
  | m::ms -> m + (addList ms)

(* A more efficient tail-recursive version.
 *)
let addList ns =
  let rec repeat ns acc =
    match ns with
    | [] -> acc
    | m::ms -> repeat ms (m + acc)
  in
  repeat ns 0
