(* length : 'a list -> int
 *
 * The call (length xs) returns the length of the list xs.
 *)
let rec length (xs:'a list) : int =
  match xs with
  | [] -> 0
  | _::xs -> 1 + length xs

(* A more efficient tail-recursive version. 
*)
let length xs =
  let rec repeat xs acc =
    match xs with
    | [] -> acc
    | _::xs -> repeat xs (1 + acc)
  in
  repeat xs 0
	   
