(* pow : int -> int -> int

 The call (pow m n) returns m raised to the n. Three solutions.
*)
let rec pow (m:int) (n:int) : int =
  match n = 0 with
  | true  -> 1
  | false -> m * (pow m (n - 1))

let rec pow (m:int) (n:int) : int =
  if n = 0 then 1 else m * (pow m (n - 1))

let pow (m:int) (n:int) : int =
  let rec repeat n acc =
    match n = 0 with
    | true  -> acc
    | false -> repeat (n - 1) (m * acc)
  in
  repeat n 1
