let rec winner electionResults =
  let rec repeat results =
    match results with
    | [] -> failwith "winner: no candidates"
    | [(candidate, votes)] -> (candidate, votes)
    | (candidate, votes)::rest ->
       let (candidate', votes') = repeat rest
       in
       match votes > votes' with
       | true  -> (candidate, votes)
       | false -> (candidate', votes') in
  let (winner, _) = repeat electionResults
  in
  winner
